<template>
  <div>
    <div class="container">

          <div class="row">
            <div class="h2 titulo">Método de búsqueda: </div>
          </div>
          <div class="row">
              <div class="btn-group btn-group-toggle" data-toggle="buttons">
                <button type="button" class="btn btn-primary" @click="formSucursal">
                  <input type="radio" name="options" id="option1" v-model="selectSucursal"> Sucursal
                </button>
                <button type="button" class="btn btn-primary" @click="formRegional">
                  <input type="radio" name="options" id="option1" v-model="selectRegional"> Regional
                </button>
              </div>
          </div>

          <!--Formulario de búsqueda por sucursal-->
        <form v-if="selectSucursal === true">
            <div class="form-row mt-3">
              <div class="form-group col-md-6">
                <label for="fecha_1">Fecha Inicio: </label>
                <input type="date" class="form-control" id="fecha_1" name="fecha_1" v-model="fecha_1"/>
                <small id="demo" class="form-text text-danger" v-if="!fecha_1">
                  *Campo requerido.
                </small>
              </div>
              <div class="form-group col-md-3">
                <label for="fecha_2">Fecha fin: </label>
                <input type="date" class="form-control" id="fecha_2" name="fecha_2" v-model="fecha_2"/>
                <small id="demo" class="form-text text-danger" v-if="!fecha_2">
                  *Campo requerido.
                </small>
              </div>
              <div class="form-group col-md-3">
                <label for="sucursal">Sucursal: </label>
                <select class="custom-select" name="sucursal" id="sucursal" v-model="sucursal">
                  <option selected></option>
                    <option value="xalapa">Xalapa</option>
                    <option value="teziutlan">Teziutlán</option>
                    <option value="oaxaca">Oaxaca</option>
                    <option value="puebla">Puebla</option>
                    <option value="huamantla">Huamantla</option>
                </select>
                <small id="demo" class="form-text text-danger" v-if="!sucursal">
                  *Campo requerido.
                </small>
              </div>
          </div>

          <button type="button" class="btn btn-primary" @click="buscarPorRangoFechaSucursal">Buscar</button>
        </form>

      <!--Formulario de búsqueda por regional-->
        <form v-if="selectRegional === true">
            <div class="form-row mt-3">
              <div class="form-group col-md-6">
                <label for="fecha_1">Fecha Inicio: </label>
                <input type="date" class="form-control" id="fecha_1" name="fecha_1" v-model="fecha_1"/>
                <small id="demo" class="form-text text-danger" v-if="!fecha_1">
                  *Campo requerido.
                </small>
              </div>
              <div class="form-group col-md-3">
                <label for="fecha_2">Fecha fin: </label>
                <input type="date" class="form-control" id="fecha_2" name="fecha_2" v-model="fecha_2"/>
                <small id="demo" class="form-text text-danger" v-if="!fecha_2">
                  *Campo requerido.
                </small>
              </div>
              <div class="form-group col-md-3">
                <label for="regional">Regional: </label>
                <select class="custom-select" name="regional" id="regional" v-model="regional">
                  <option selected></option>
                  <option value="veracruz">Veracruz</option>
                  <option value="oaxaca">Oaxaca</option>
                  <option value="puebla">Puebla</option>
                </select>
                <small id="demo" class="form-text text-danger" v-if="!regional">
                  *Campo requerido.
                </small>
              </div>
          </div>

          <button type="button" class="btn btn-primary" @click="buscarPorRangoFechaRegional">Buscar</button>
        </form>

          <v-app>         
            <v-card-title>
              
              <v-spacer></v-spacer>
              <v-text-field
                v-model="search"
                append-icon="mdi-magnify"
                label="Buscar . . ."
                single-line
                hide-details
              ></v-text-field>
            </v-card-title>
            <v-data-table
              :headers="headers"
              :items="lista"
              :items-per-page="5"
              :search="search"
              class="elevation-1">
            </v-data-table>
          </v-app>

          
      
          <div class="row">
            <div class="table-responsive">
              <table class="table table-striped header table-hover">
                <thead>
                  <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Nombre AC</th>
                    <th scope="col">Clientes</th>
                    <th scope="col">Monto</th>
                    <th scope="col">Banco</th>
                    <th scope="col">Fecha desembolso</th>
                    <th scope="col">Sucursal</th>
                    <th scope="col">Regional</th>
                  </tr>
                </thead>
                <tbody>
                  <!--<tr>
                    <th>Id</th>
                    <th>Nombre_ac</th>
                    <th>Clientes</th>
                    <th>Monto</th>
                    <th>Banco</th>
                    <th>Fecha_desembolso</th>
                    <th>Sucursal</th>
                    <th>Regional</th>
                  </tr>-->
                  <tr v-for="item in displayedDesembolsos" :key="item.id">
                    <th>{{ item.id }}</th>
                    <td>{{ item.nombre_ac }}</td>
                    <td>{{ item.clientes }}</td>
                    <td>{{ item.monto }}</td>
                    <td>{{ item.banco }}</td>
                    <td>{{ item.fecha_desembolso }}</td>
                    <td>{{ item.sucursal }}</td>
                    <td>{{ item.regional }}</td>
                  </tr>

                </tbody>
              </table>
            </div>
          </div>
          
          <div class="row">
              <button class="btn btn-sm btn-primary" id="exportToExcel" > Excel</button>   
          </div>
          
          <!--     Ciclo para mostrar numero de páginas dentro de un array       -->
          <div class="btn-group col-md-2 offset-md-5">

              <button
                type="button"
                class="btn btn-sm btn-primary"
                v-if="page != 1"
                @click="page--"
                > Prev. </button>
              <button
                type="button"
                class="btn btn-sm btn-primary"
                v-for="pageNumber in pages.slice(page-1, page+5)"
                @click="page = pageNumber"
                :key="pageNumber"
                >{{pageNumber}}</button>
              <button
                type="button"
                @click="page++"
                v-if="page < pages.length"
                class="btn btn-sm btn-primary"
              >>></button>
          </div>

        </div>
        <!--Footer/Pie de pagina-->
          <Footer></Footer>
  </div>
        
</template>

<script>
import axios from "axios";
import Footer from "./Footer.vue";

$(document).ready( () => {
  /*$('#table').DataTable( {
    "ajax": "../../src/controllers/controllerJSON.js",
        "columns": [
            { "data": "id" },
            { "data": "nombre_ac" },
            { "data": "clientes" },
            { "data": "monto" },
            { "data": "banco" },
            { "data": "fecha_desembolso" },
            { "data": "sucursal" },
            { "data": "regional" }
        ]
  });*/
  $("#exportToExcel").click(function () {
    $("#table").table2excel({
      exclude:".noExl",
      name: "Desembolsos",
      //formats: ["xlsx","txt", "csv"], //Tipo de archivos a exportar ("xlsx","txt", "csv", "xls")
      //position: 'button',  // Posicion que se muestran los botones puedes ser: (top, bottom)
      //bootstrap: false,//Usar lo estilos de css de bootstrap para los botones (true, false)
      fileName: "Desembolsos",    //Nombre del archivo 
      fileext: ".xls"
    });
  });
});

    export default {
      name: "Home",
      components: {
        Footer,
      },
      data() {
          return {
            search: '',
            lista: [],
            sucursal: "",
            regional: "",
            fecha_1: "",
            fecha_2: "",
            selectSucursal: false,
            selectRegional: false,
            page: 1,
            perPage: 6,
            pages: [],
            headers: [
              { text: 'ID', value: 'id', /*sortable: false*/},
              { text: 'Nombre AC', value: 'nombre_ac', /*sortable: false*/},
              { text: 'Clientes', value: 'clientes', /*sortable: false*/},
              { text: 'Monto', value: 'monto', /*sortable: false*/},
              { text: 'Banco', value: 'banco', /*sortable: false*/},
              { text: 'Fecha desembolso', value: 'fecha_desembolso', /*sortable: false*/},
              { text: 'Sucursal', value: 'sucursal' /*sortable: false*/},
              { text: 'Regional', value: 'regional' /*sortable: false*/},
            ],
          };
      },
      /*created() {
          this.getOperaciones();
      },*/
      methods: {

          getOperaciones() {
          //const res = await this.axios.get(`${this.baseURL}/operaciones`);
            axios
              .get('/operaciones')
              .then((response) => {
                this.lista = response.data;
                console.log(response);
                //console.log(response);
                //return this.paginate(this.lista);
              })
              .catch((e) => console.log(e));
          },
          setLista() {
            let numberOfPages = Math.ceil(this.lista.length / this.perPage);
            for (let i = 1; i <= numberOfPages; i++) {
                this.pages.push(i);
            }
          },
          paginate(lista) {
            let page = this.page;
            let perPage = this.perPage;
            let from = (page * perPage) - perPage;
            let to = (page * perPage);
            return lista.slice(from, to);
          },

          formSucursal: function(){
          this.selectSucursal = true;
          this.selectRegional = false;
          this.fecha_1 = "";
          this.fecha_2 = "";
          this.sucursal = "";
          this.lista = [];
          //console.log(this.lista.length);
          this.pages = [];
          this.page = 1;
        },
        formRegional: function(){
          this.selectRegional = true;
          this.selectSucursal = false;
          this.fecha_1 = "";
          this.fecha_2 = "";
          this.regional = "";
          this.lista = [];
          //console.log(this.lista.length);
          this.pages = [];
          this.page = 1;
        },
        buscarPorRangoFechaSucursal() {
          axios.post('/operaciones/sucursal', {
            fecha_1: this.fecha_1,
            fecha_2: this.fecha_2,
            sucursal: this.sucursal,
          })
          .then((res) => {
            this.fecha_1 = this.fecha_1,
            this.fecha_2 = this.fecha_2,
            this.sucursal = this.sucursal,
            console.log(res);
            this.lista = res.data;
          })
          .catch((err) => {
            console.log(err);
          })
        },

        buscarPorRangoFechaRegional() {
          axios
            .post('/operaciones/regional', {
              fecha_1: this.fecha_1,
              fecha_2: this.fecha_2,
              regional: this.regional,
            })
            .then((res) => {
              this.fecha_1 = this.fecha_1,
              this.fecha_2 = this.fecha_2,
              this.regional = this.regional,
              console.log(this.regional);
              console.log(res);
              this.lista = res.data;
            })
            .catch((err) => {
              console.log(err);
            })
        },

      },
      watch: {
        lista(){
          this.setLista();
        }
      },
      computed: {
          displayedDesembolsos: function () {
          return this.paginate(this.lista);
          }
      },

      created() {
        this.getOperaciones();
      },

    };
</script>